
#include <I2C_Rotary_003.h>

// Declare 3 rotary objects.
// - All use the same I2C address
// - But different switch nrs 
I2C_Rotary Rotary_SW1(0xA0, 1);  // SW1
I2C_Rotary Rotary_SW2(0xA0, 2);  // SW2
I2C_Rotary Rotary_SW3(0xA0, 3);  // SW3

void setup() 
{
   Wire.begin();
   Serial.begin(38400);
}


void ChangeAddress(byte OldAddress, byte NewAddress)
{
   Serial.println();
   Serial.println();
   Serial.print( F("Change Address from 0x") );
   Serial.print( OldAddress, HEX );
   Serial.print( F(" to 0x") );
   Serial.print( NewAddress, HEX );
   Serial.println();

   switch( Rotary_SW1.ChangeAddress(OldAddress, NewAddress) )
   {  case 0:  Serial.println( F("- New address already set") ); break;
      case 1:  Serial.println( F("- New address occupied")    ); break;
      case 2:  Serial.print  ( F("- Switched to new address 0x") ); 
               Serial.println( NewAddress, HEX ); break;
      case 3:  Serial.println( F("- Address-change failed")   ); break;
   }
}


void loop() 
{
   ChangeAddress(0xA0, 0xA2);
   delay(500);
}
