#include <I2C_Rotary_003.h>

// Declare 3 rotary objects.
// - All use the same I2C address
// - But different switch nrs 
I2C_Rotary Rotary_SW1(0xA0, 1);  // SW1
I2C_Rotary Rotary_SW2(0xA0, 2);  // SW2
I2C_Rotary Rotary_SW3(0xA0, 3);  // SW3

void setup() 
{
   Wire.begin();
   Serial.begin(38400);

   Serial.println();
   Serial.println( F("Turn a rotary an see what happens") );
   Serial.println();
   
   // Set parameters for Rotary_SW1
   Rotary_SW1.m_MinValue =   0.0;
   Rotary_SW1.m_MaxValue = 100.0;
   Rotary_SW1.m_StepSize =   1.0;
   Rotary_SW1.m_Value    =       0.0;
   Rotary_SW1.SetDirection(0);
   Rotary_SW1.SetAccelleration(1);

   // Set parameters for Rotary_SW2
   Rotary_SW2.m_MinValue =  40.0;
   Rotary_SW2.m_MaxValue =  50.0;
   Rotary_SW2.m_StepSize =   0.1;
   Rotary_SW2.m_Value    =      40.0;
   Rotary_SW2.SetDirection(1);
   Rotary_SW2.SetAccelleration(0);

   // Set parameters for Rotary_SW3
   Rotary_SW3.m_MinValue =  -40000.0;
   Rotary_SW3.m_MaxValue =  +40000.0;
   Rotary_SW3.m_StepSize =     100.0;
   Rotary_SW3.m_Value    =   10000.0;
   Rotary_SW3.SetDirection(0);
   Rotary_SW3.SetAccelleration(0);
}


void loop() 
{
   delay(50);

   // Scan status of the rotary buttons:
   byte Button1 = Rotary_SW1.Button();
   byte Button2 = Rotary_SW2.Button();
   byte Button3 = Rotary_SW3.Button();

   // Scan status of the rotary clicks:
   int  Clicks1 = Rotary_SW1.Clicks();
   int  Clicks2 = Rotary_SW2.Clicks();
   int  Clicks3 = Rotary_SW3.Clicks();

   // Just write the result to the serial port
   if(Button1)
   {  Serial.print( F("SW1 : Button = ") );
      Serial.println( Button1 );
      Serial.println();
   }
   if(Button2)
   {  Serial.print( F("SW2 : Button = ") );
      Serial.println( Button2 );
      Serial.println();
   }
   if(Button3)
   {  Serial.print( F("SW3 : Button = ") );
      Serial.println( Button3 );
      Serial.println();
   }
   
   if(Clicks1)
   {  Serial.print( F("SW1 : Clicks = ") );
      Serial.println( Clicks1 );
      Serial.print( F("SW1 : Value  = ") );
      Serial.println( Rotary_SW1.m_Value );
      Serial.println();
   }
   if(Clicks2)
   {  Serial.print( F("SW2 : Clicks = ") );
      Serial.println( Clicks2 );
      Serial.print( F("SW2 : Value  = ") );
      Serial.println( Rotary_SW2.m_Value );
      Serial.println();
   }
   if(Clicks3)
   {  Serial.print( F("SW3 : Clicks = ") );
      Serial.println( Clicks3 );
      Serial.print( F("SW3 : Value  = ") );
      Serial.println( Rotary_SW3.m_Value );
      Serial.println();
   }
}
