

#include <I2C_Rotary_003.h>



// Declare 3 rotary objects.
// - All use the same I2C address
// - But different switch nrs 
I2C_Rotary Rotary_SW1(0xA0, 1);  // SW1
I2C_Rotary Rotary_SW2(0xA0, 2);  // SW2
I2C_Rotary Rotary_SW3(0xA0, 3);  // SW3

void setup() 
{  Wire.begin();
   Serial.begin(38400);
}


void loop() 
{  
   Serial.println(); 
   Serial.println(); 
   Serial.println( F("I2C bus scanner")); 
   Serial.println( F("Searching for I2C-ROT-003")); 
   Serial.println(); 

   // Scan the bus to find a rotary controller
   byte Count = 0;
   for(uint8_t Address = 8; ; Address += 2)
   { 
      if(Address == 0)
      {  // End of the list
         if(Count == 0)
         {  Serial.println( F("Rotary controller not found") ); 
         }
         break;
      }

      byte Response[20];
      Rotary_SW1.m_Address = Address >> 1;
      Rotary_SW1.ReadRegister( 0xF1, Response, 20 );
      if(Rotary_SW1.m_XmitStatus == 0)
      {  if(    (Rotary_SW1.m_RecvCount > 5)
             && (Response[0] == Address)
             && (Response[1] == 0xF1) )
         {  Serial.print( F("Bingo. Address = 0x") ); 
            Serial.println(Address, HEX); 
            Serial.print( F("Model   = ") ); 
            Serial.println((const char *) &Response[2]);
             
            Rotary_SW1.ReadRegister( 0xF2, Response, 20 );
            Serial.print( F("Version = ") ); 
            Serial.println((const char *) &Response[2]);
   
            Rotary_SW1.ReadRegister( 0xF3, Response, 20 );
            Serial.print( F("Release = ") ); 
            Serial.println((const char *) &Response[2]);
   
            Count += 1;
         }
         else
         {  Serial.print( F("Unknown device at Address = 0x") ); 
            Serial.println(Address, HEX); 
         }
      }
   }
   
   delay(2000);   
}
